using System.Numerics;

using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.verticalVelocityNumberBox.ValueChanged += verticalVelocityNumberBox_ValueChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Vertical Velocity ѹ ڽ   óϱ - verticalVelocityNumberBox_ValueChanged(sender, e)

        /// <summary>
        /// Vertical Velocity ѹ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void verticalVelocityNumberBox_ValueChanged(NumberBox sender, NumberBoxValueChangedEventArgs e)
        {
            if(double.IsNaN(e.OldValue))
            {
                return;
            }

            if(this.scrollView != null)
            {
                this.scrollView.ScrollBy
                (
                    0,
                    0,
                    new ScrollingScrollOptions(ScrollingAnimationMode.Disabled, ScrollingSnapPointsMode.Ignore)
                );

                float verticalConstantVelocity = (float)this.verticalVelocityNumberBox.Value;

                if(e.NewValue <= 30.0 && e.NewValue >= -30)
                {
                    if(e.NewValue < e.OldValue)
                    {
                        if(this.scrollView.VerticalOffset == 0)
                        {
                            verticalConstantVelocity = 30;
                        }
                        else
                        {
                            verticalConstantVelocity = -30;
                        }
                    }
                    else
                    {
                        if(this.scrollView.VerticalOffset == this.scrollView.ScrollableHeight)
                        {
                            verticalConstantVelocity = -30;
                        }
                        else
                        {
                            verticalConstantVelocity = 30;
                        }
                    }
                }
                else if(e.NewValue < 30.0 && this.scrollView.VerticalOffset == 0)
                {
                    verticalConstantVelocity = 30;
                }
                else if (e.NewValue > 30.0 && this.scrollView.VerticalOffset == this.scrollView.ScrollableHeight)
                {
                    verticalConstantVelocity = -30;
                }

                this.verticalVelocityNumberBox.Value = verticalConstantVelocity;

                this.scrollView.AddScrollVelocity
                (
                    new Vector2(0f, verticalConstantVelocity),
                    new Vector2()
                );
            }
        }

        #endregion
    }
}